
import java.lang.*;
import java.io.*;
import java.awt.image.*;

public class dither{

  static globals jva;
  
  public static void init_display(){
    
    int crv, cbu, cgu, cgv;
    int y, u, v, r, g, b;
    int i;
    
    int pixs, mapr, mapg, mapb;
    int idx = 0;
    int mapSize = 0;
    IndexColorModel t;
    byte reds[] = null;
    byte greens[] = null;
    byte blues[] = null;
    int indexed = 0;    
    
    System.out.println("Pixel size is " + jva.cmodel.getPixelSize());
    if (jva.cmodel.getPixelSize() < 24){  
	t = (IndexColorModel) jva.cmodel;
	mapSize = t.getMapSize();
	System.out.println("Colormap size is " + t.getMapSize());
	reds = new byte[t.getMapSize()];
	greens = new byte[t.getMapSize()];
	blues = new byte[t.getMapSize()];
/*	t.getReds(reds);
	t.getGreens(greens);
	t.getBlues(blues);*/	
    }
    /* matrix coefficients */
    crv = jva.convmat[jva.matrix_coefficients][0];
    cbu = jva.convmat[jva.matrix_coefficients][1];
    cgu = jva.convmat[jva.matrix_coefficients][2];
    cgv = jva.convmat[jva.matrix_coefficients][3];

	/* color allocation:
     * i is the (internal) 8 bit color number, it consists of separate
     * bit fields for Y, U and V: i = (yyyyuuvv), we don't use yyyy=0000
     * yyyy=0001 and yyyy=1111, this leaves 48 colors for other applications
     *
     * the allocated colors correspond to the following Y, U and V values:
     * Y:   40, 56, 72, 88, 104, 120, 136, 152, 168, 184, 200, 216, 232
     * U,V: -48, -16, 16, 48
     *
     * U and V values span only about half the color space; this gives
     * usually much better quality, although highly saturated colors can
     * not be displayed properly
     *
     * translation to R,G,B is implicitly done by the color look-up table
     */
    for (i=32; i<240; i++) {
      /* color space conversion */
      y = 16*((i>>4)&15) + 8;
      u = 32*((i>>2)&3)  - 48;
      v = 32*(i&3)       - 48;

      y = 76309 * (y - 16); /* (255/219)*65536 */
      
      r = jva.clp[((y + crv*v + 32768)>>16) + 384];
      g = jva.clp[((y - cgu*u -cgv*v + 32768)>>16) + 384];
      b = jva.clp[((y + cbu*u + 32786)>>16) + 384]; 

      if (jva.cmodel.getPixelSize() >= 24){
	pixs = (r << 16) | (g << 8) | b;
	/*System.out.println("I: " + i + " pixs: " + pixs);*/
	mapr = jva.cmodel.getRed(pixs);
	mapg = jva.cmodel.getGreen(pixs);
	mapb = jva.cmodel.getBlue(pixs);
	jva.cmap[idx] = (mapr << 16) | (mapg << 8) | mapb;
      }
      else{
/*	System.out.println("R: " + r + " G: " + g + " B: " + b);*/
	if (jva.cmodel.getPixelSize() < 24){
	  reds[idx] = (byte) r; greens[idx] = (byte) g; blues[idx] = (byte) b;
/*	  indexed = findClosest(reds, greens, blues, r, g, b, mapSize);*/
	  jva.cmap[idx] = idx;
	}
      }
      jva.pixel[i] = idx;
      idx++;
    }

    if (jva.cmodel.getPixelSize() < 24){
      t = new IndexColorModel(8, 256, reds, greens, blues);
      jva.cmodel = (ColorModel) t;
    }
    
    ord4x4_dither_init ();
  }

  /****************************************************************************
    
    4x4 ordered dither
    
    Threshold pattern:
    
    0  8  2 10
    12  4 14  6
    3 11  1  9
    15  7 13  5
    
    ****************************************************************************/
  public static void ord4x4_dither_init (){
    
    int i, j, v;
    int ctab[];

    ctab = new int[256 + 32];
    
    for (i = 0; i < 256 + 16; i++)
      {
	v = (i - 8) >> 4;
	if (v < 2)
	  v = 2;
	else if (v > 14)
	  v = 14;
	for (j = 0; j < 16; j++)
	  jva.ytab[16 * i + j] = jva.pixel[(v << 4) + j];
      }
    
    for (i = 0; i < 256 + 32; i++)
      {
	v = (i + 48 - 128) >> 5;
	if (v < 0)
	  v = 0;
	else if (v > 3)
	  v = 3;
	ctab[i] = v;
      }
    
    for (i = 0; i < 255 + 15; i++)
      for (j = 0; j < 255 + 15; j++)
	jva.uvtab[256 * i + j] = (char) ((ctab[i + 16] << 6) | (ctab[j + 16] << 4) | (ctab[i] << 2) | ctab[j]);
  }
  
  public static void ord4x4_dither_frame (int src[][]){
    
    int i, j;
    int py = 0;
    int pu = 0;
    int pv = 0;
    int y[], u[], v[];
 /*   unsigned char *py = src[0];
    unsigned char *pu = src[1];
    unsigned char *pv = src[2];
   */ 
    int width, height, cwidth;
    char uvtab[];
    int ytab[];
    int temp;
    int idx = 0;
    
    uvtab = jva.uvtab;
    ytab = jva.ytab;
    y = src[0];
    u = src[1];
    v = src[2];
    
    if (jva.expand != 0)
      {
	width = 2 * jva.coded_picture_width;
	height = 2 * jva.coded_picture_height;
	cwidth = 2 * jva.chrom_width;
      }
    else
      {
	width = jva.coded_picture_width;
	height = jva.coded_picture_height;
	cwidth = jva.chrom_width;
      }
    
    for (j = 0; j < height; j += 4){
      
	long uv;
	
	/* line j + 0 */
	for (i = 0; i < width; i += 8){
	  uv = (long) uvtab[(u[pu] << 8) | v[pv]];
	  pu++;pv++;
	  temp = ytab[((y[py]) << 4) | ((int) uv & 15)];
	  py++;
	  jva.pix[idx] = jva.cmap[temp];
	  idx++;
	  temp = ytab[((y[py] + 8) << 4) | ((int) uv >> 4)];
	  py++;
	  jva.pix[idx] = jva.cmap[temp];
	  idx++;
	  uv = (long) uvtab[((u[pu] << 8) | v[pv]) + 1028];
	  pu++; pv++;
	  temp = ytab[((y[py] + 2) << 4) | ((int) uv & 15)];
	  py++;
	  jva.pix[idx] = jva.cmap[temp];
	  idx++;
	  temp = ytab[((y[py] + 10) << 4) | ((int) uv >> 4)];
	  py++;
	  jva.pix[idx] = jva.cmap[temp];
	  idx++;
	  uv = (long) uvtab[(u[pu] << 8) | v[pv]];
	  pu++; pv++;
	  temp = ytab[((y[py]) << 4) | ((int) uv & 15)];
	  py++;
	  jva.pix[idx] = jva.cmap[temp];
	  idx++;
	  temp = ytab[((y[py] + 8) << 4) | ((int) uv >> 4)];
	  py++;
	  jva.pix[idx] = jva.cmap[temp];
	  idx++;
	  uv = (long) uvtab[((u[pu] << 8) | v[pv]) + 1028];
	  pu++; pv++;
	  temp = ytab[((y[py] + 2) << 4) | ((int) uv & 15)];
	  py++;
	  jva.pix[idx] = jva.cmap[temp];
	  idx++;
	  temp = ytab[((y[py] + 10) << 4) | ((int) uv >> 4)];
	  py++;
	  jva.pix[idx] = jva.cmap[temp];
	  idx++;
	}
	
	pu -= cwidth;
	pv -= cwidth;
	
	/* line j + 1 */
	for (i = 0; i < width; i += 8)
	  {
	    uv = (long) uvtab[((u[pu] << 8) | v[pv]) + 2056];
	    pu++; pv++;
	    temp = ytab[((y[py] + 12) << 4) | ((int) uv >> 4)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    temp = ytab[((y[py] + 4) << 4) | ((int) uv & 15)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    uv = (long) uvtab[((u[pu] << 8) | v[pv]) + 3084];
	    pu++; pv++;
	    temp = ytab[((y[py] + 14) << 4) | ((int) uv >> 4)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    temp = ytab[((y[py] + 6) << 4) | ((int) uv & 15)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    uv = (long) uvtab[((u[pu] << 8) | v[pv]) + 2056];
	    pu++; pv++;
	    temp = ytab[((y[py] + 12) << 4) | ((int) uv >> 4)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    temp = ytab[((y[py] + 4) << 4) | ((int) uv & 15)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    uv = (long) uvtab[((u[pu] << 8) | v[pv]) + 3084];
	    pu++;pv++;
	    temp = ytab[((y[py] + 14) << 4) | ((int) uv >> 4)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    temp = ytab[((y[py] + 6) << 4) | ((int) uv & 15)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	  }
	
	/* line j + 2 */
	for (i = 0; i < width; i += 8)
	  {
	    uv = (long) uvtab[((u[pu] << 8) | v[pv]) + 1542];
	    pu++; pv++;
	    temp = ytab[((y[py] + 3) << 4) | ((int) uv & 15)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    temp = ytab[((y[py] + 11) << 4) | ((int) uv >> 4)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    uv = (long) uvtab[((u[pu] << 8) | v[pv]) + 514];
	    pu++; pv++;
	    temp = ytab[((y[py] + 1) << 4) | ((int) uv & 15)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    temp = ytab[((y[py] + 9) << 4) | ((int) uv >> 4)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    uv = (long) uvtab[((u[pu] << 8) | v[pv]) + 1542];
	    pu++; pv++;
	    temp = ytab[((y[py] + 3) << 4) | ((int) uv & 15)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    temp = ytab[((y[py] + 11) << 4) | ((int) uv >> 4)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    uv = (long) uvtab[((u[pu] << 8) | v[pv]) + 514];
	    pu++; pv++;
	    temp = ytab[((y[py] + 1) << 4) | ((int) uv & 15)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    temp = ytab[((y[py] + 9) << 4) | ((int) uv >> 4)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	  }
	
	pu -= cwidth;
	pv -= cwidth;
	
	/* line j + 3 */
	for (i = 0; i < width; i += 8)
	  {
	    uv = (long) uvtab[((u[pu] << 8) | v[pv]) + 3598];
	    pu++; pv++;
	    temp = ytab[((y[py] + 15) << 4) | ((int) uv >> 4)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    temp = ytab[((y[py] + 7) << 4) | ((int) uv & 15)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    uv = (long) uvtab[((u[pu] << 8) | v[pv]) + 2570];
	    pu++; pv++;
	    temp = ytab[((y[py] + 13) << 4) | ((int) uv >> 4)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    temp = ytab[((y[py] + 5) << 4) | ((int) uv & 15)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    uv = (long) uvtab[((u[pu] << 8) | v[pv]) + 3598];
	    pu++; pv++;
	    temp = ytab[((y[py] + 15) << 4) | ((int) uv >> 4)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    temp = ytab[((y[py] + 7) << 4) | ((int) uv & 15)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    uv = (long) uvtab[((u[pu] << 8) | v[pv]) + 2570];
	    pu++; pv++;
	    temp = ytab[((y[py] + 13) << 4) | ((int) uv >> 4)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	    temp = ytab[((y[py] + 5) << 4) | ((int) uv & 15)];
	    py++;
	    jva.pix[idx] = jva.cmap[temp];
	    idx++;
	  }
      }
  }

  public static int findClosest(byte reds[], byte greens[], byte blues[], int r, int g, int b, int mapSize){

	double min = 99999999;
	int res = 0;
	int dr, dg, db;
	double cmin;

	dr = java.lang.Math.abs(reds[0] - r);
	dg = java.lang.Math.abs(greens[0] - g);
	db = java.lang.Math.abs(blues[0] - b);

	min = (dr * dr) + (dg * dg) + (db * db);
	min = java.lang.Math.sqrt(min);

	for (int i = 1; i < mapSize; i++){
		dr = java.lang.Math.abs(reds[i] - r);
		dg = java.lang.Math.abs(greens[i] - g);
		db = java.lang.Math.abs(blues[i] - b);
		cmin = (dr * dr) + (dg * dg) + (db * db);
		cmin = java.lang.Math.sqrt(cmin);
		if (cmin < min){
			min = cmin;
			res = i;
		}
	}

	return res;
  }

}
