
import java.lang.*;

public class recon{

  static globals jva;

  public static void reconstruct(int bx, int by, int P, int bdx, int bdy){

    int w,h,lx,lx2,dx,dy,xp,yp,comp,sum;
    int x,y,mode,xvec,yvec;
    int src[][];
    int offsrc[];

    src = new int[3][];
    offsrc = new int[3];
    
    x = (bx/16)+1; y = (by/16)+1;
    lx = jva.coded_picture_width;
    
    if (jva.mv_outside_frame != 0) {
      lx2 = jva.coded_picture_width + 64;
      src[0] = jva.edgeframeorig[0];offsrc[0] = jva.edgeframe[0];
      src[1] = jva.edgeframeorig[1];offsrc[1] = jva.edgeframe[1];
      src[2] = jva.edgeframeorig[2];offsrc[2] = jva.edgeframe[2];
    }
    else {
      lx2 = jva.coded_picture_width;
      offsrc[0] = offsrc[1] = offsrc[2] = 0;
      src[0] = jva.oldrefframe[0];
      src[1] = jva.oldrefframe[1];
      src[2] = jva.oldrefframe[2];
    }
    
    mode = jva.modemap[y][x];
    
    if (P != 0) {
      /* P prediction */
      if (jva.adv_pred_mode != 0) {
	w = 8; h = 8;
	/* Y*/
	for (comp = 0; comp < 4; comp++) {
	  xp = bx + ((comp&1)<<3);
	  yp = by + ((comp&2)<<2);
	  recon_comp_obmc(src[0], offsrc[0], jva.newframe[0], lx,lx2,comp,w,h,xp,yp);
	}
	if (mode == jva.tmnh.MODE_INTER4V) {
	  
	  sum = jva.MV[0][1][y][x] + jva.MV[0][2][y][x]+ 
  	        jva.MV[0][3][y][x] + jva.MV[0][4][y][x];
	  dx = jva.sign(sum)*(jva.roundtab[java.lang.Math.abs(sum)%16] + 
			      (java.lang.Math.abs(sum)/16)*2);
	  
	  sum = jva.MV[1][1][y][x]+jva.MV[1][2][y][x]+ 
 	        jva.MV[1][3][y][x]+jva.MV[1][4][y][x];
	  dy = jva.sign(sum)*(jva.roundtab[java.lang.Math.abs(sum)%16] + 
			      (java.lang.Math.abs(sum)/16)*2);
	  
	}
	else {
	  dx = jva.MV[0][0][y][x];
	  dy = jva.MV[1][0][y][x];
	  /* chroma rounding */
	  dx = ( dx % 4 == 0 ? dx >> 1 : (dx>>1)|1 );
	  dy = ( dy % 4 == 0 ? dy >> 1 : (dy>>1)|1 );
	}
	lx>>=1;bx>>=1; lx2>>=1; 
	by>>=1;
	/* Chroma */
	recon_comp(src[1], offsrc[1], jva.newframe[1], lx,lx2,w,h,bx,by,dx,dy,1);
	recon_comp(src[2], offsrc[2], jva.newframe[2], lx,lx2,w,h,bx,by,dx,dy,2);
      }
      else { /* normal prediction mode */
	/* P prediction */
	w = 16; h = 16;
	dx = jva.MV[0][0][y][x];
	dy = jva.MV[1][0][y][x];
	
	/* Y */
	recon_comp(src[0], offsrc[0], jva.newframe[0], lx,lx2,w,h,bx,by,dx,dy,0);
	
	lx>>=1; w>>=1; bx>>=1; lx2>>=1; 
	h>>=1; by>>=1;  
	/* chroma rounding */
	dx = ( dx % 4 == 0 ? dx >> 1 : (dx>>1)|1 );
	dy = ( dy % 4 == 0 ? dy >> 1 : (dy>>1)|1 );
	
	/* Chroma */
	recon_comp(src[1], offsrc[1], jva.newframe[1], lx,lx2,w,h,bx,by,dx,dy,1);
	recon_comp(src[2], offsrc[2], jva.newframe[2], lx,lx2,w,h,bx,by,dx,dy,2);
      }
    }
    
    else {
      /* B forward prediction */
      if (jva.adv_pred_mode != 0) {
	if (mode == jva.tmnh.MODE_INTER4V) {
	  w = 8; h = 8;
	  /* Y*/
	  xvec = yvec = 0;
	  for (comp = 0; comp < 4; comp++) {
	    xvec += dx = ((jva.trb*jva.MV[0][comp+1][y][x])/jva.trd) + bdx;
	    yvec += dy = ((jva.trb*jva.MV[1][comp+1][y][x])/jva.trd) + bdy;
	    xp = bx + ((comp&1)<<3);
	    yp = by + ((comp&2)<<2);
	    recon_comp(src[0], offsrc[0], jva.bframe[0], lx,lx2,w,h,xp,yp,dx,dy,0);
	  }
	  
	  /* chroma rounding (table 16/H.263) */
	  dx = jva.sign(xvec)*(jva.roundtab[java.lang.Math.abs(xvec)%16] 
			       + (java.lang.Math.abs(xvec)/16)*2);
	  dy = jva.sign(yvec)*(jva.roundtab[java.lang.Math.abs(yvec)%16] + 
			       (java.lang.Math.abs(yvec)/16)*2);
	  
	  lx>>=1;bx>>=1; lx2>>=1;
	  by>>=1;
	  /* Chroma */
	  recon_comp(src[1], offsrc[1], jva.bframe[1], lx,lx2,w,h,bx,by,dx,dy,1);
	  recon_comp(src[2], offsrc[2], jva.bframe[2], lx,lx2,w,h,bx,by,dx,dy,2);
	}
	else {  /* adv_pred_mode but 16x16 vector */
	  w = 16; h = 16;
	  
	  dx = ((jva.trb*jva.MV[0][0][y][x])/jva.trd) + bdx;
	  dy = ((jva.trb*jva.MV[1][0][y][x])/jva.trd) + bdy;
	  /* Y */
	  recon_comp(src[0], offsrc[0], jva.bframe[0], lx,lx2,w,h,bx,by,dx,dy,0);
	  
	  lx>>=1; w>>=1; bx>>=1; lx2>>=1;
	  h>>=1; by>>=1;  
	  
	  xvec = 4*dx;
	  yvec = 4*dy;
	  
	  /* chroma rounding (table 16/H.263) */
	  dx = jva.sign(xvec)*(jva.roundtab[java.lang.Math.abs(xvec)%16] + 
			       (java.lang.Math.abs(xvec)/16)*2);
	  dy = jva.sign(yvec)*(jva.roundtab[java.lang.Math.abs(yvec)%16] + 
			       (java.lang.Math.abs(yvec)/16)*2);
	  
	/* Chroma */
	  recon_comp(src[1], offsrc[1], jva.bframe[1], lx,lx2,w,h,bx,by,dx,dy,1);
	  recon_comp(src[2], offsrc[2], jva.bframe[2], lx,lx2,w,h,bx,by,dx,dy,2);
	}
      }
      else { /* normal B forward prediction */
	
	w = 16; h = 16;
	dx = ((jva.trb*jva.MV[0][0][y][x])/jva.trd) + bdx;
	dy = ((jva.trb*jva.MV[1][0][y][x])/jva.trd) + bdy;
	/* Y */
	recon_comp(src[0], offsrc[0], jva.bframe[0], lx,lx2,w,h,bx,by,dx,dy,0);
	
	lx>>=1; w>>=1; bx>>=1; lx2>>=1;
	h>>=1; by>>=1;  
	
	xvec = 4*dx;
	yvec = 4*dy;
	
	/* chroma rounding (table 16/H.263) */ 
	dx = jva.sign(xvec)*(jva.roundtab[java.lang.Math.abs(xvec)%16] + 
			     (java.lang.Math.abs(xvec)/16)*2);
	dy = jva.sign(yvec)*(jva.roundtab[java.lang.Math.abs(yvec)%16] + 
			     (java.lang.Math.abs(yvec)/16)*2);
	
	/* Chroma */
	recon_comp(src[1], offsrc[1], jva.bframe[1], lx,lx2,w,h,bx,by,dx,dy,1);
	recon_comp(src[2], offsrc[2], jva.bframe[2], lx,lx2,w,h,bx,by,dx,dy,2);
      }
    }
    
  }

  public static void recon_comp(int src[], int osrc, int dst[], int lx,
				int lx2, int w, int h, int x, int y,
				int dx, int dy, int chroma){

    int xint, xh, yint, yh;
    int s[], d[];
    int os, od;
    
    xint = dx>>1;
    xh = dx & 1;
    yint = dy>>1;
    yh = dy & 1;
    
    /* origins */
    s = src; os = osrc + lx2*(y+yint) + x + xint;
    d = dst; od = lx*y + x;
    
    if (xh == 0 && yh == 0)
      if (w!=8)
	rec(s, os, d, od, lx,lx2,h);
      else
	recc(s, os, d, od, lx,lx2,h);
    else if (xh == 0 && yh != 0)
      if (w!=8)
	recva(s, os, d, od, lx,lx2,h);
      else 
	recvc(s, os, d, od, lx,lx2,h);
    else if (xh != 0 && yh == 0)
      if (w!=8)
	rech(s, os, d, od, lx,lx2,h);
      else
	rechc(s, os, d, od, lx,lx2,h);
    else 
      if (w!=8)
	rec4(s, os, d, od, lx,lx2,h);
      else
	rec4c(s, os, d, od, lx,lx2,h);
    
  }

  public static void rec(int s[], int os, int d[], int od, 
			 int lx, int lx2,int h){
    
    int j;

    for (j=0; j<h; j++){
      d[0 + od] = s[0 + os];
      d[1 + od] = s[1 + os];
      d[2 + od] = s[2 + os];
      d[3 + od] = s[3 + os];
      d[4 + od] = s[4 + os];
      d[5 + od] = s[5 + os];
      d[6 + od] = s[6 + os];
      d[7 + od] = s[7 + os];
      d[8 + od] = s[8 + os];
      d[9 + od] = s[9 + os];
      d[10 + od] = s[10 + os];
      d[11 + od] = s[11 + os];
      d[12 + od] = s[12 + os];
      d[13 + od] = s[13 + os];
      d[14 + od] = s[14 + os];
      d[15 + od] = s[15 + os];
      os+= lx2;
      od+= lx;
    }
  }

  public static void recc(int s[], int os, int d[], int od, 
			 int lx, int lx2,int h){
    
    int j;
    
    for (j=0; j<h; j++){
      d[0 + od] = s[0 + os];
      d[1 + od] = s[1 + os];
      d[2 + od] = s[2 + os];
      d[3 + od] = s[3 + os];
      d[4 + od] = s[4 + os];
      d[5 + od] = s[5 + os];
      d[6 + od] = s[6 + os];
      d[7 + od] = s[7 + os];
      os += lx2;
      od += lx;
    }
  }

  public static void reco(int s[], int os, int d[], int od, int lx,
			  int lx2, int addflag, int c, int xa, int xb,
			  int ya, int yb){


    int i, j;


    if (addflag == 0) {
      for (j = ya; j < yb; j++) {
	for (i = xa; i < xb; i++) {
	  d[od + i] = s[os + i] * jva.OM[c][j][i];
	}
	os+= lx2;
	od+= lx;
      }
    }
    else {
      for (j = ya; j < yb; j++) {
	for (i = xa; i < xb; i++) {
	  d[od + i] += s[os + i] * jva.OM[c][j][i];
	}
	os+= lx2;
	od+= lx;
      }
    }
    
  }
  

  public static void rech(int s[], int os, int d[], int od, 
			  int lx, int lx2, int h){

    
    int dp[], sp[];
    int j;
    long s1, s2;


    sp = s;
    dp = d;

    for (j = 0; j<h; j++){
      s1 = sp[0 + os];
      dp[0 + od] = (int) ((long)(s1+(s2=sp[1 + os])+1)>>1);
      dp[1 + od] = (int) ((long)(s2+(s1=sp[2 + os])+1)>>1);
      dp[2 + od] = (int) ((long)(s1+(s2=sp[3 + os])+1)>>1);
      dp[3 + od] = (int) ((long)(s2+(s1=sp[4 + os])+1)>>1);
      dp[4 + od] = (int) ((long)(s1+(s2=sp[5 + os])+1)>>1);
      dp[5 + od] = (int) ((long)(s2+(s1=sp[6 + os])+1)>>1);
      dp[6 + od] = (int) ((long)(s1+(s2=sp[7 + os])+1)>>1);
      dp[7 + od] = (int) ((long)(s2+(s1=sp[8 + os])+1)>>1);
      dp[8 + od] = (int) ((long)(s1+(s2=sp[9 + os])+1)>>1);
      dp[9 + od] = (int) ((long)(s2+(s1=sp[10 + os])+1)>>1);
      dp[10 + od] = (int) ((long)(s1+(s2=sp[11 + os])+1)>>1);
      dp[11 + od] = (int) ((long)(s2+(s1=sp[12 + os])+1)>>1);
      dp[12 + od] = (int) ((long)(s1+(s2=sp[13 + os])+1)>>1);
      dp[13 + od] = (int) ((long)(s2+(s1=sp[14 + os])+1)>>1);
      dp[14 + od] = (int) ((long)(s1+(s2=sp[15 + os])+1)>>1);
      dp[15 + od] = (int) ((long)(s2+sp[16 + os]+1)>>1);
      os+= lx2;
      od+= lx;
    }

  }

  public static void rechc(int s[], int os, int d[], int od,
			   int lx, int lx2, int h){

    int dp[], sp[];
    int j;
    long s1, s2;
    

    sp = s;
    dp = d;

    for (j = 0; j<h; j++){
      s1 = sp[0 + os];
      dp[0 + od] = (int) ((long)(s1+(s2=sp[1 + os])+1)>>1);
      dp[1 + od] = (int) ((long)(s2+(s1=sp[2 + os])+1)>>1);
      dp[2 + od] = (int) ((long)(s1+(s2=sp[3 + os])+1)>>1);
      dp[3 + od] = (int) ((long)(s2+(s1=sp[4 + os])+1)>>1);
      dp[4 + od] = (int) ((long)(s1+(s2=sp[5 + os])+1)>>1);
      dp[5 + od] = (int) ((long)(s2+(s1=sp[6 + os])+1)>>1);
      dp[6 + od] = (int) ((long)(s1+(s2=sp[7 + os])+1)>>1);
      dp[7 + od] = (int) ((long)(s2+(s1=sp[8 + os])+1)>>1);
      os+= lx2;
      od+= lx;
    }
      
  }

  public static void recho(int s[], int os, int d[], int od,
			   int lx, int lx2, int addflag, int c,
			   int xa, int xb, int ya, int yb){


    int i, j;
    

    if (addflag == 0) {
      for (j = ya; j < yb; j++) {
	for (i = xa; i < xb; i++) {
	  d[od + i] = (int) (((long) (s[os + i] + s[os + i + 1] + 1)) >> 1) * jva.OM[c][j][i];
	}
	os+= lx2;
	od+= lx;
      }
    }
    else {
      for (j = ya; j < yb; j++) {
	for (i = xa; i < xb; i++) {
	  d[od + i] += (int) (((long) (s[os + i] + s[os + i + 1] + 1)) >> 1) * jva.OM[c][j][i];
	}
	os+= lx2;
	od+= lx;
      }
    }

  }

  public static void recva(int s[], int os, int d[], int od,
			   int lx, int lx2, int h){


    int sp2;
    int j;


    sp2 = os + lx2;

    for (j = 0; j < h; j++){
      d[od + 0] = (int) ((long)(s[os + 0] + s[sp2 + 0] + 1)>>1);
      d[od + 1] = (int) ((long)(s[os + 1] + s[sp2 + 1] + 1)>>1);
      d[od + 2] = (int) ((long)(s[os + 2] + s[sp2 + 2] + 1)>>1);
      d[od + 3] = (int) ((long)(s[os + 3] + s[sp2 + 3] + 1)>>1);
      d[od + 4] = (int) ((long)(s[os + 4] + s[sp2 + 4] + 1)>>1);
      d[od + 5] = (int) ((long)(s[os + 5] + s[sp2 + 5] + 1)>>1);
      d[od + 6] = (int) ((long)(s[os + 6] + s[sp2 + 6] + 1)>>1);
      d[od + 7] = (int) ((long)(s[os + 7] + s[sp2 + 7] + 1)>>1);
      d[od + 8] = (int) ((long)(s[os + 8] + s[sp2 + 8] + 1)>>1);
      d[od + 9] = (int) ((long)(s[os + 9] + s[sp2 + 9] + 1)>>1);
      d[od + 10] = (int) ((long)(s[os + 10] + s[sp2 + 10] + 1)>>1);
      d[od + 11] = (int) ((long)(s[os + 11] + s[sp2 + 11] + 1)>>1);
      d[od + 12] = (int) ((long)(s[os + 12] + s[sp2 + 12] + 1)>>1);
      d[od + 13] = (int) ((long)(s[os + 13] + s[sp2 + 13] + 1)>>1);
      d[od + 14] = (int) ((long)(s[os + 14] + s[sp2 + 14] + 1)>>1);
      d[od + 15] = (int) ((long)(s[os + 15] + s[sp2 + 15] + 1)>>1);      
      os += lx2;
      sp2 += lx2;
      od += lx;
    }

  }

  public static void recvc(int s[], int os, int d[], int od,
			   int lx, int lx2, int h){


    int sp2;
    int j;
    

    sp2 = os + lx2;
    
    for (j = 0; j < h; j++){
      d[od + 0] = (int) ((long)(s[os + 0] + s[sp2 + 0] + 1)>>1);
      d[od + 1] = (int) ((long)(s[os + 1] + s[sp2 + 1] + 1)>>1);
      d[od + 2] = (int) ((long)(s[os + 2] + s[sp2 + 2] + 1)>>1);
      d[od + 3] = (int) ((long)(s[os + 3] + s[sp2 + 3] + 1)>>1);
      d[od + 4] = (int) ((long)(s[os + 4] + s[sp2 + 4] + 1)>>1);
      d[od + 5] = (int) ((long)(s[os + 5] + s[sp2 + 5] + 1)>>1);
      d[od + 6] = (int) ((long)(s[os + 6] + s[sp2 + 6] + 1)>>1);
      d[od + 7] = (int) ((long)(s[os + 7] + s[sp2 + 7] + 1)>>1);
      os += lx2;
      sp2 += lx2;
      od += lx;
    }
  }

  
  public static void recvo(int s[], int os, int d[], int od,
			   int lx, int lx2, int addflag, int c,
			   int xa, int xb, int ya, int yb){

    int sp2;
    int i, j;
    

    sp2 = os + lx2;
    
    if (addflag == 0) {
      for (j = ya; j < yb; j++) {
	for (i = xa; i < xb; i++) {
	  d[od + i] = (int) (((long) (s[os + i] + s[sp2 + i] + 1)) >> 1) * jva.OM[c][j][i];
	}
	os+= lx2;
	sp2+= lx2;
	od+= lx;
      }
    }
    else {
      for (j = ya; j < yb; j++) {
	for (i = xa; i < xb; i++) {
	  d[od + i]+= (int) (((long) (s[os + i] + s[sp2 + i] + 1)) >> 1) * jva.OM[c][j][i];
	}
	os+= lx2;
	sp2+= lx2;
	od+= lx;
      }
    }
  }

  public static void rec4(int s[], int os, int d[], int od,
			  int lx, int lx2, int h){


    int j, sp2;
    long s1, s2, s3, s4;


    sp2 = os + lx2;
/*    System.out.println("Sp2 is " + sp2 + " Lx2 is " + lx2 + " os is " + os);*/
    for (j = 0; j < h; j++){
      s1 = (long) s[os + 0]; s3 = (long) s[sp2 + 0];
      d[od + 0] = (int) ((long)(s1 + (s2 = (long) s[os + 1]) + s3 + (s4 = (long) s[sp2 + 1]) + 2)>>2);

      d[od + 1] = (int) ((long)(s2 + (s1 = (long) s[os + 2]) + s4 + (s3 = (long) s[sp2 + 2]) + 2)>>2);

      d[od + 2] = (int) ((long)(s1 + (s2 = (long) s[os + 3]) + s3 + (s4 = (long) s[sp2 + 3]) + 2)>>2);

      d[od + 3] = (int) ((long)(s2 + (s1 = (long) s[os + 4]) + s4 + (s3 = (long) s[sp2 + 4]) + 2)>>2);

      d[od + 4] = (int) ((long)(s1 + (s2 = (long) s[os + 5]) + s3 + (s4 = (long) s[sp2 + 5]) + 2)>>2);

      d[od + 5] = (int) ((long)(s2 + (s1 = (long) s[os + 6]) + s4 + (s3 = (long) s[sp2 + 6]) + 2)>>2);

      d[od + 6] = (int) ((long)(s1 + (s2 = (long) s[os + 7]) + s3 + (s4 = (long) s[sp2 + 7]) + 2)>>2);

      d[od + 7] = (int) ((long)(s2 + (s1 = (long) s[os + 8]) + s4 + (s3 = (long) s[sp2 + 8]) + 2)>>2);

      d[od + 8] = (int) ((long)(s1 + (s2 = (long) s[os + 9]) + s3 + (s4 = (long) s[sp2 + 9]) + 2)>>2);

      d[od + 9] = (int) ((long)(s2 + (s1 = (long) s[os + 10]) + s4 + (s3 = (long) s[sp2 + 10]) + 2)>>2);

      d[od + 10] = (int) ((long)(s1 + (s2 = (long) s[os + 11]) + s3 + (s4 = (long) s[sp2 + 11]) + 2)>>2);
      
      d[od + 11] = (int) ((long)(s2 + (s1 = (long) s[os + 12]) + s4 + (s3 = (long) s[sp2 + 12]) + 2)>>2);

      d[od + 12] = (int) ((long)(s1 + (s2 = (long) s[os + 13]) + s3 + (s4 = (long) s[sp2 + 13]) + 2)>>2);

      d[od + 13] = (int) ((long)(s2 + (s1 = (long) s[os + 14]) + s4 + (s3 = (long) s[sp2 + 14]) + 2)>>2);

      d[od + 14] = (int) ((long)(s1 + (s2 = (long) s[os + 15]) + s3 + (s4 = (long) s[sp2 + 15]) + 2)>>2);

      d[od + 15] = (int) ((long)(s2 + s[os + 16] + s4 + s[sp2 + 16] + 2) >> 2);
      
      os += lx2;
      sp2 += lx2;
      od += lx;
    }
  }


  public static void rec4c(int s[], int os, int d[], int od,
			   int lx, int lx2, int h){

    
    int j, sp2;
    long s1, s2, s3, s4;


    sp2 = os + lx2;

    for (j = 0; j < h; j++){
      s1 = (long) s[os + 0]; s3 = (long) s[sp2 + 0];
      d[od + 0] = (int) ((long)(s1 + (s2 = (long) s[os + 1]) + s3 + (s4 = (long) s[sp2 + 1]) + 2)>>2);

      d[od + 1] = (int) ((long)(s2 + (s1 = (long) s[os + 2]) + s4 + (s3 = (long) s[sp2 + 2]) + 2)>>2);

      d[od + 2] = (int) ((long)(s1 + (s2 = (long) s[os + 3]) + s3 + (s4 = (long) s[sp2 + 3]) + 2)>>2);

      d[od + 3] = (int) ((long)(s2 + (s1 = (long) s[os + 4]) + s4 + (s3 = (long) s[sp2 + 4]) + 2)>>2);

      d[od + 4] = (int) ((long)(s1 + (s2 = (long) s[os + 5]) + s3 + (s4 = (long) s[sp2 + 5]) + 2)>>2);

      d[od + 5] = (int) ((long)(s2 + (s1 = (long) s[os + 6]) + s4 + (s3 = (long) s[sp2 + 6]) + 2)>>2);

      d[od + 6] = (int) ((long)(s1 + (s2 = (long) s[os + 7]) + s3 + (s4 = (long) s[sp2 + 7]) + 2)>>2);

      d[od + 7] = (int) ((long)(s2 + s[os + 8] + s4 + s[sp2 + 8] + 2) >> 2);
      
      os += lx2;
      sp2 += lx2;
      od += lx;
    }

  }

  
  public static void rec4o(int s[], int os, int d[], int od,
			   int lx, int lx2, int addflag,
			   int c, int xa, int xb, int ya, int yb){
    
    int sp2;
    int i, j;


    
    sp2 = os + lx2;
    
    if (addflag == 0) {
      for (j = ya; j < yb; j++){
	for (i = xa; i < xb; i++){
	  d[od + i] = (int) (((long) (s[os + i] + s[sp2 + i] + s[os + i + 1] + s[sp2 + i + 1] + 2)) >> 2) * jva.OM[c][j][i];
	}
	os+= lx2;
	sp2+= lx2;
	od+= lx;
      }
    }
    else {
      for (j = ya; j < yb; j++) {
	for (i = xa; i < xb; i++) {
	  d[od + i] += (int) (((long) (s[os + i] + s[sp2 + i] + s[os + i + 1] + s[sp2 + i + 1] + 2)) >> 2) * jva.OM[c][j][i];
	}
	os+= lx2;
	sp2+= lx2;
	od+= lx;
      }
    }
  }

  static void recon_comp_obmc(int src[], int osrc, int dst[],
			      int lx, int lx2, int comp,
			      int w,int h,int x,int y){

    
    int j,k;
    int xmb,ymb;
    int c8,t8,l8,r8;
    int xit,xib,xir,xil;
    int yit,yib,yir,yil;
    int vect,vecb,vecr,vecl;
    int nx[],ny[],xint[],yint[],xh[],yh[];
    int p[], pd, od;
    int s[];
    
    nx = new int[5]; ny = new int[5]; xint = new int[5]; yint = new int[5];
    xh = new int[5]; yh = new int[5];

    s = new int[5];
    p = new int[64];

    vect = vecb = vecr = vecl = xit = yit = xil = yil = xir = yir = xib = yib = 0;

    xmb = (x>>4)+1;
    ymb = (y>>4)+1;
    
    c8 = (jva.modemap[ymb][xmb] == jva.tmnh.MODE_INTER4V ? 1 : 0);
    t8 = (jva.modemap[ymb-1][xmb] == jva.tmnh.MODE_INTER4V ? 1 : 0);
    l8 = (jva.modemap[ymb][xmb-1] == jva.tmnh.MODE_INTER4V ? 1 : 0);
    r8 = (jva.modemap[ymb][xmb+1] == jva.tmnh.MODE_INTER4V ? 1 : 0);
    
    switch (comp+1) {
    case 1:
      if (t8 != 0)
	vect = 3;
      else
	vect = 0;
      
      if (c8 != 0)
	vecb = 3;
      else
	vecb = 0;

      if (l8 != 0)
	vecl = 2;
      else
	vecl = 0;

      if (c8 != 0)
	vecr = 2;
      else
	vecr = 0;
      
      yit = ymb-1 ; xit = xmb;
      yib = ymb   ; xib = xmb;
      yil = ymb   ; xil = xmb-1;
      yir = ymb   ; xir = xmb;
      if (ymb == 1) {
	yit = ymb;
	if (c8 != 0)
	  vect = 1;
	else
	  vect = 0;
      }
      if (xmb == 1) {
	xil = xmb;
	if (c8 != 0)
	  vecl = 1;
	else
	  vecl = 0;
      }
      break;
    case 2:
      if (t8 != 0)
	vect = 4;
      else
	vect = 0;
      
      if (c8 != 0)
	vecb = 4;
      else
	vecb = 0;
      
      if (c8 != 0)
	vecl = 1;
      else
	vecl = 0;

      if (r8 != 0)
	vecr = 1;
      else 
	vecr = 0;

      yit = ymb-1 ; xit = xmb;
      yib = ymb   ; xib = xmb;
      yil = ymb   ; xil = xmb;
      yir = ymb   ; xir = xmb+1;
      if (ymb == 1) {
	yit = ymb;
	if (c8 != 0)
	  vect = 2;
	else
	  vect = 0;
      }
      if (xmb == jva.mb_width) {
	xir = xmb;
	if (c8 != 0)
	  vecr = 2;
	else
	  vecr = 0;
      }
      break;
    case 3:
      if (c8 != 0)
	vect = 1;
      else
	vect = 0;

      if (c8 != 0)
	vecb = 3;
      else
	vecb = 0;

      if (l8 != 0)
	vecl = 4;
      else
	vecl = 0;

      if (c8 != 0)
	vecr = 4;
      else
	vecr = 0;

      yit = ymb  ; xit = xmb;
      yib = ymb  ; xib = xmb;
      yil = ymb  ; xil = xmb-1;
      yir = ymb  ; xir = xmb;
      if (xmb == 1){
	xil = xmb;
	if (c8 != 0)
	  vecl = 3;
	else
	  vecl = 0;
      }
      break;
    case 4:
      if (c8 != 0)
	vect = 2;
      else
	vect = 0;
      
      if (c8 != 0)
	vecb = 4;
      else
	vecb = 0;

      if (c8 != 0)
	vecl = 3;
      else
	vecl = 0;

      if (r8 != 0)
	vecr = 3;
      else
	vecr = 0;
      
      yit = ymb  ; xit = xmb;
      yib = ymb  ; xib = xmb;
      yil = ymb  ; xil = xmb;
      yir = ymb  ; xir = xmb+1;
      if (xmb == jva.mb_width) {
	xir = xmb;
	if (c8 != 0)
	  vecr = 4;
	else
	  vecr = 0;
      }
      break;
    default:
      System.out.println("Illegal block number in recon_comp_obmc (recon.java)");
      System.exit(1);
      break;
    }

    if (c8 != 0){
      nx[0] = jva.MV[0][comp + 1][ymb][xmb];
      ny[0] = jva.MV[1][comp + 1][ymb][xmb];
    }
    else{
      nx[0] = jva.MV[0][0][ymb][xmb];
      ny[0] = jva.MV[1][0][ymb][xmb];
    }
    
    nx[1] = jva.MV[0][vect][yit][xit]; ny[1] = jva.MV[1][vect][yit][xit];
    nx[2] = jva.MV[0][vecb][yib][xib]; ny[2] = jva.MV[1][vecb][yib][xib];
    nx[3] = jva.MV[0][vecr][yir][xir]; ny[3] = jva.MV[1][vecr][yir][xir];
    nx[4] = jva.MV[0][vecl][yil][xil]; ny[4] = jva.MV[1][vecl][yil][xil];
    
    for (k = 0; k < 5; k++) {
      xint[k] = nx[k]>>1;
      xh[k] = nx[k] & 1;
      yint[k] = ny[k]>>1;
      yh[k] = ny[k] & 1;
/*      s[k] = src + lx2*(y+yint[k]) + x + xint[k];*/
      s[k] = osrc + lx2*(y + yint[k]) + x + xint[k];
    }
    
    /*d = dst + lx*y + x;*/
    od = (lx * y) + x;
    
    if (xh[0] == 0 && yh[0] == 0)
      reco(src, s[0], p, 0,8,lx2,0,0,0,8,0,8);
    else if (xh[0] == 0 && yh[0] != 0)
      recvo(src, s[0], p, 0,8,lx2,0,0,0,8,0,8);
    else if (xh[0] != 0 && yh[0] == 0)
      recho(src, s[0], p, 0,8,lx2,0,0,0,8,0,8);
    else /* if (xh[] && yh[]) */
      rec4o(src, s[0], p, 0,8,lx2,0,0,0,8,0,8);
    
    if (xh[1] == 0 && yh[1] == 0)
      reco(src, s[1], p, 0,8,lx2,1,1,0,8,0,4);
    else if (xh[1] == 0 && yh[1] != 0)
      recvo(src, s[1], p, 0,8,lx2,1,1,0,8,0,4);
    else if (xh[1] != 0 && yh[1] == 0)
      recho(src, s[1], p, 0,8,lx2,1,1,0,8,0,4);
    else /* if (xh[] && yh[]) */
      rec4o(src, s[1], p, 0,8,lx2,1,1,0,8,0,4);
    
    if (xh[2] == 0 && yh[2] == 0)
      reco(src, s[2]+(lx2<<2), p, 32,8,lx2,1,2,0,8,4,8);
    else if (xh[2] == 0 && yh[2] != 0)
      recvo(src, s[2]+(lx2<<2), p, 32,8,lx2,1,2,0,8,4,8);
    else if (xh[2] != 0 && yh[2] == 0)
      recho(src, s[2]+(lx2<<2), p, 32,8,lx2,1,2,0,8,4,8);
    else /* if (xh[] && yh[]) */
      rec4o(src, s[2]+(lx2<<2), p, 32,8,lx2,1,2,0,8,4,8);
    
    if (xh[3] == 0 && yh[3] == 0)
      reco(src, s[3], p, 0,8,lx2,1,3,4,8,0,8);
    else if (xh[3] == 0 && yh[3] != 0)
      recvo(src, s[3], p, 0,8,lx2,1,3,4,8,0,8);
    else if (xh[3] != 0 && yh[3] == 0)
      recho(src, s[3], p, 0,8,lx2,1,3,4,8,0,8);
    else /* if (xh[] && yh[]) */
      rec4o(src, s[3], p, 0,8,lx2,1,3,4,8,0,8);
    
    if (xh[4] == 0 && yh[4] == 0)
      reco(src, s[4], p, 0,8,lx2,1,4,0,4,0,8);
    else if (xh[4] == 0 && yh[4] != 0)
      recvo(src, s[4], p, 0,8,lx2,1,4,0,4,0,8);
    else if (xh[4] != 0&& yh[4] == 0)
      recho(src, s[4], p, 0,8,lx2,1,4,0,4,0,8);
    else /* if (xh[] && yh[]) */
      rec4o(src, s[4], p, 0,8,lx2,1,4,0,4,0,8);
    
    pd = 0;
    for (j = 0; j < 8; j++) {
      dst[od + 0] = (p[pd + 0] + 4 )>>3;	
      dst[od + 1] = (p[pd + 1] + 4 )>>3;	
      dst[od + 2] = (p[pd + 2] + 4 )>>3;	
      dst[od + 3] = (p[pd + 3] + 4 )>>3;	
      dst[od + 4] = (p[pd + 4] + 4 )>>3;	
      dst[od + 5] = (p[pd + 5] + 4 )>>3;	
      dst[od + 6] = (p[pd + 6] + 4 )>>3;	
      dst[od + 7] = (p[pd + 7] + 4 )>>3;	
      od += lx;
      pd += 8;
    }
    
  }
  
}
