
import java.lang.*;
import java.io.*;

public class tmndec{

  static globals jva;
  static int loopflag;

  public static void printbits(long code, int bits, int len){
    
    int i;
    
    for (i = 0; i < (int) len; i++)
      System.out.print((code >> (bits - 1 - i)) & 1);
  }

  public static void options(String argv[]){

    loopflag = 0; // No looping for output file;
    jva.framerate = 0;
    jva.verbose = 0; // Not implemented yet
    jva.outtype = 3; // For ppm output type
    jva.refidct = 0;
    jva.expand = 0;
    jva.trace = 0;
    jva.quiet = 0;
  }


  public static void initdecoder(){

    int i, cc, size;
    int oclp;
    
    jva.clp = new int[1024];

    oclp = 384;

    for (i = -384; i < 640; i++)
      jva.clp[oclp + i] = (i < 0) ? 0: ((i > 255) ? 255 : i);

    jva.matrix_coefficients = 5;
    jva.horizontal_size = jva.tmnh.MBC * 16;
    jva.vertical_size = jva.tmnh.MBR * 16;

    if (jva.source_format != jva.tmnh.SF_QCIF){
      System.out.println("This version was compiled for SQCIF format (128x96)");
      System.exit(1);
    }

    jva.mb_width = jva.horizontal_size/16;
    jva.mb_height = jva.vertical_size/16;
    jva.coded_picture_width = 16*jva.mb_width;
    jva.coded_picture_height = 16*jva.mb_height;
    jva.chrom_width =  jva.coded_picture_width>>1;
    jva.chrom_height = jva.coded_picture_height>>1;
    jva.blk_cnt = 6;

    for (cc=0; cc<3; cc++) {
      if (cc==0)
	size = jva.coded_picture_width*jva.coded_picture_height;
      else
	size = jva.chrom_width*jva.chrom_height;
      
      jva.refframe[cc] = new int[size];
      jva.oldrefframe[cc] = new int[size];
      jva.bframe[cc] = new int[size];
    }
    
    for (cc=0; cc<3; cc++) {
      if (cc==0) {
	size = (jva.coded_picture_width+64)*(jva.coded_picture_height+64);
	jva.edgeframeorig[cc] = new int[size];
	jva.edgeframe[cc] = ((jva.coded_picture_width + 64) * 32) + 32;
      }
      else {
	size = (jva.chrom_width+32)*(jva.chrom_height+32);
	jva.edgeframeorig[cc] = new int[size];
	jva.edgeframe[cc] = ((jva.chrom_width + 32) * 16) + 16;
      }
    }

    if (jva.expand != 0) {
      for (cc=0; cc<3; cc++) {
	if (cc==0)
	  size = jva.coded_picture_width*jva.coded_picture_height*4;
	else
	  size = jva.chrom_width*jva.chrom_height*4;
	
	jva.exnewframe[cc] = new int[size];
      }
    }

    /* IDCT */
    if (jva.refidct != 0)
      jva.NPACIdctRef.init_idctref();
    else
      jva.NPACIdct.init_idct();
    
  }

  public static void error(String text){

    System.err.println(text);
    System.exit(1);
    
  }

  


}
